function xdot = reactorLeda(t, x, params, light_function)
% 4-variable model from Leda in Chemical Physics 2009

    k = params(1:10);    
    c0 = params(11);
    cmin = params(12);
    bc = params(13);
    b = params(14);

    xdot(1) = -k(1) * x(1) * x(2) + k(2) * x(2) - 2 * k(3) * x(1)^2 + k(4) * x(1) * ( c0 - x(3) ) / (c0 - x(3) + cmin);
    xdot(2) = -3 * k(1) * x(1) * x(2) - 2 * k(2) * x(2) - k(3) * x(1)^2 + k(7) * x(4) + k(9) * x(3) + light_function(t) * (c0 - x(3)) / (bc / b + 1);
    xdot(3) = 2 * k(4) * x(1) * (c0 - x(3)) / (c0 - x(3) + cmin) - k(9) * x(3) - k(10) * x(3) + light_function(t) * (c0 - x(3)) / (bc / b + 1);
    xdot(4) = 2 * k(1) * x(1) * x(2) + k(2) * x(2) + k(3) * x(1)^2 - k(7) * x(4);
%     xdot(5) = 0;
    
    xdot = xdot';